/*========================================================================
 * Copyright (c) 2009 Tampere University of Technology, Finland
 * 
 * Permission is hereby granted, free of charge, to any person 
 * obtaining a copy of this software and associated documentation 
 * files (the "Software"), to deal in the Software without restriction, 
 * including without limitation the rights to use, copy, modify, merge, 
 * publish, distribute, sublicense, and/or sell copies of the Software, 
 * and to permit persons to whom the Software is furnished to do so, 
 * subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *======================================================================*/

function tr(s) { return s; }

function ComicWidget(parent)
{
    QWidget.call(this, parent);

	//this.styleSheet = "QLabel{ background-color: rgba(50,50,50,0%); } ";

	this.url = "http://www.sarjis.info/feed/paiva/rss/";
	this.itemDescriptions = new Array();

	this.browser = new QWebView(this);
	this.browser["loadFinished(bool)"].connect(this, this.loadFinished);
	this.browserItem = 0;
	this.browser.page().linkDelegationPolicy = QWebPage.DelegateAllLinks;

	this.nextButton = new QPushButton(tr("Next"),this);
	this.nextButton["clicked"].connect(this, function() {
			this.previousButton.enabled = true;
			this.browserItem = this.browserItem + 1;
			if(this.browserItem == this.itemDescriptions.length) {
				this.browserItem = 0;
			}
			print(this.browserItem);
			this.browser.setHtml(this.itemDescriptions[this.browserItem]);
		});
	this.previousButton = new QPushButton(tr("Previous"),this);
	this.previousButton.enabled = false;
	this.previousButton["clicked"].connect(this, function() {
			this.browserItem = this.browserItem - 1;
			if(this.browserItem == -1) {
				this.browserItem = this.itemDescriptions.length - 1;
			}
			print(this.browserItem);
			this.browser.setHtml(this.itemDescriptions[this.browserItem]);
		});
		
	this.comicComboBox = new QComboBox();
    this.comicComboBox.addItem(tr("Sarjis.info - todays comics"));
    this.comicComboBox.addItem(tr("XKCD"));
    this.comicComboBox.addItem(tr("Dilbert"));
    this.comicComboBox.addItem(tr("Viivi & Wagner (via Sarjis.info)"));
    this.comicComboBox.addItem(tr("PhD (Piled Higher & Deeper)"));
    this.comicComboBox["activated(int)"].connect(this, function(index) {
    		switch (index) {
        	// Sarjis.info - todays comics
        	case 0:
            	this.url = "http://www.sarjis.info/feed/paiva/rss/";
            	break;
        	// XKCD
        	case 1:
            	this.url = "http://xkcd.com/rss.xml";
            	break;
        	// Dilbert
        	case 2:
            	this.url = "http://feeds2.feedburner.com/DilbertDailyStrip?format=xml";
            	break;
        	// Viivi & Wagner (via Sarjis.info)
        	case 3:
            	this.url = "http://www.sarjis.info/feed/viivi-ja-wagner/rss/";
            	break;
			// PhD
            case 4:
            	this.url = "http://www.phdcomics.com/gradfeed.php";
            	break;
			}
			this.loadFeed();
    	});
    this.comicComboBox.activated(0);

	var hBoxLayout = new QHBoxLayout();
	hBoxLayout.addWidget(this.previousButton,0,0);
	hBoxLayout.addStretch();
	hBoxLayout.addWidget(this.comicComboBox,Qt.AlignCenter,0);
	hBoxLayout.addStretch();
	hBoxLayout.addWidget(this.nextButton,0,0);

	this.layout = new QVBoxLayout(this);
	this.layout.addLayout(hBoxLayout);
	this.layout.addWidget(this.browser,Qt.AlignCenter,0);

    this.windowTitle = tr("Comics Widget");
    
    this.resize(800,480);
}

ComicWidget.prototype = new QWidget();


ComicWidget.prototype.loadFinished = function(ok) {

}

ComicWidget.prototype.loadFeed = function() {
	this.imageUrls = [];
	var url = this.url;
	var accessManager = new QNetworkAccessManager(this);
	accessManager["finished(QNetworkReply*)"].connect(this, this.flickrReplyFinished);
	accessManager.get(new QNetworkRequest(new QUrl(url)));
}

ComicWidget.prototype.flickrReplyFinished = function(reply) {
	var xml = new QXmlStreamReader();
	xml.addData(reply.readAll());
	var descriptionString;
	var titleString;
	
	this.itemDescriptions = [];
	
	while (!xml.atEnd()) {
        xml.readNext();
        
        // We are at the start of an element
        if(xml.isStartElement()) {
            if(xml.name() == "item") {
            	var currentTopLevelTag = xml.name().toString();
            	titleString = "";
			}
			if(xml.name() == "channel") {
				var currentTopLevelTag = xml.name().toString();
			}
			var currentTag = xml.name().toString();
			print(currentTag);
		} 
        // We are at the end of an element
        else if (xml.isEndElement()) {
        	
        } 
        // Collecting items we would probably want to save in the tree
        else if (xml.isCharacters() && !xml.isWhitespace()) {
        	if(currentTopLevelTag == "item" && currentTag == "title") {
				titleString = xml.text().toString();
			}
        	if(currentTopLevelTag == "item" && currentTag == "description") {
        		print(xml.text().toString());
        		this.itemDescriptions.push(
        			"<center>" + 
        			"<h3>" + titleString + "</h3>" +
        			xml.text().toString() + "</center>");
			}
        }
    }
    if (xml.hasError() && (xml.error() != QXmlStreamReader.PrematureEndOfDocumentError)) {
        print("XML ERROR:", xml.lineNumber() + ":", xml.errorString());
    }
    
    this.browser.setHtml(this.itemDescriptions[0].toString());
    this.browserItem = 0;
}

/* To use the application in standalone mode, remove the comment around this code
var wdgt = new ComicWidget();
wdgt.show();

QCoreApplication.exec();
*/

